from django.conf import settings
from django.conf.urls.defaults import *
from django.contrib import admin
from django.template import defaulttags

import preflight
import preflight.urls

admin.autodiscover()
preflight.autodiscover()

if 'gargoyle' in settings.INSTALLED_APPS:
    import gargoyle
    gargoyle.autodiscover()

handler500 = 'identityprovider.views.errors.server_error'
handler404 = 'identityprovider.views.errors.page_not_found'

urlpatterns = patterns('',
    #(r'^admin/', check_readonly(admin.site.urls)),
    (r'^admin/', include(admin.site.urls)),
    (r'^preflight/', include(preflight.urls)),
    (r'^', include('identityprovider.urls')),
)
if settings.SERVE_STATIC_MEDIA:
    urlpatterns += patterns('',
        (r'assets/identityprovider/(.*)', 'django.views.static.serve',
            {'document_root': settings.SSO_MEDIA_ROOT}),
        (r'media/(.*)', 'django.views.static.serve',
            {'document_root': settings.MEDIA_ROOT}),
)


# some custom logic to register a fake csrf_token when in django 1.1.1
# to be forward-compatible with django 1.3
# we place this here to make sure this get's registered before any
# template is rendered that may use this tag

if 'csrf_token' not in defaulttags.register.tags:
    # add the csrf_token tag to the list of the default tags
    from identityprovider.templatetags.csrf import csrf_token
    defaulttags.register.tag(csrf_token)
