# Copyright 2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).
from __future__ import absolute_import

import os


__all__ = [
    'get_django_settings',
]


def get_django_settings(*keys):
    # setup the correct django environment
    os.environ['DJANGO_SETTINGS_MODULE'] = 'django_project.settings'
    # get django settings
    from django.conf import settings

    result = dict.fromkeys(keys)
    for key in keys:
        result[key] = getattr(settings, key)

    return result

